import { Request, Response, NextFunction } from "express";
import { ModelRawNonQuery } from "../lib/model/RawNonQuery";
import { ModelRawQuery } from "../lib/model/RawQuery";
import { RawView } from "../lib/view/RawView";
import fs from 'fs';
import path from 'path';
import { UploadDirectory } from "../config/setting.config";
import { APIBase } from "./APIBase";
import { parseBody, setToZero } from "./markError";
const dir = new UploadDirectory();
const Str = require('@supercharge/strings');
var request = require("request");
const crypto = require('crypto');

export abstract class SMS {
    private _key: string;
    private _secret: string;
    private _priority: string;
    private _account: string;
    protected req: any;
    protected res: any;

    constructor() {
        this._key = "";
        this._secret = "";
        this._priority = "";
        this._account = "";
    }

    protected get key(): string {
        return this._key;
    }

    protected set key(val: string) {
        this._key = val;
    }

    protected get secret(): string {
        return this._secret;
    }

    protected set secret(val: string) {
        this._secret = val;
    }

    protected get priority(): string {
        return this._priority;
    }

    protected set priority(val: string) {
        this._priority = val;
    }

    protected get account(): string {
        return this._account;
    }

    protected set account(val: string) {
        this._account = val;
    }

    public getType(did: any) {
        let rate_type = "";
        did = "" + did + "";
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let digit = number.slice(0, 3);
        if ((digit == 800 || digit == 822 || digit == 833 || digit == 844 || digit == 855 || digit == 866 || digit == 877 || digit == 888) && number.length == 10) {
            rate_type = "toll_free";
        }
        else if (number.length == 10) {
            rate_type = "10_dlc";
        }
        else {
            rate_type = "short_code";
        }
        return rate_type;
    }

    public getRate(req: Request, res: Response, tariff: number, type: string, subcategory: string, callback: (err: any, data: any) => void) {
        let obj1 = new ModelRawQuery(req, res);
        obj1.qrysql = "SELECT IFNULL(`MT_rates`,0)`MT_rates` FROM `sms_rate` WHERE `id_tariff`='" + tariff + "' AND `category`='" + type + "'  AND `subcategory`='" + subcategory + "' LIMIT 1";
        obj1.prepare()
        obj1.execute((err, sms_rate) => {
            console.log(err, sms_rate);
            if (err == 1) {
                let sr: any = [];
                sr = sms_rate.length > 0 ? sms_rate : [Object.assign({ MT_rates: 0 }, sms_rate[0])];
                callback(err, sr)
            }
            else {
                callback(err, "")
            }
        });
    }

    public getLrnDetails(req: Request, res: Response, did: any, callback: (err: any, data: any) => void) {
        console.log("Did::=>", did);
        did = "" + did + "";
        let len = did.length - 10;
        let number = did.slice(len, did.length);
        let npa = number.slice(0, 3);
        let nxx = number.slice(3, 6);
        let obj1 = new ModelRawQuery(req, res);
        obj1.qrysql = "SELECT npa,block, lata, ocn, lata, state, co_name_spec_c, li.category, IFNULL(o.id,0) idoperator, IFNULL(sr.rates,0) rates,IFNULL(o.name,'') `name` FROM (SELECT * FROM `lerg_info` WHERE npa='" + npa + "' AND nxx='" + nxx + "') li LEFT JOIN `lerg_operator` lo  ON lo.operator=li.co_name_spec_c AND lo.category=li.category LEFT JOIN `operator_mapping` om ON om.idlerg_operator=lo.idlerg_operator LEFT JOIN `operator` o ON om.idoperator=o.id LEFT JOIN (SELECT * FROM `surcharge_rates` WHERE direction='outbound' AND subtype='SMS' AND category='none' AND TYPE='10DLC') sr ON sr.idoperator=o.id";
        obj1.prepare()
        obj1.execute((err, lrn_details) => {
            console.log("====", err, lrn_details);
            if (err == 1) {
                callback('', { message: "LRN Found Successfully", status: 200, data: lrn_details })
            } else {
                callback({ message: "Query Error", status: 502 }, '')
            }
        });
    }

    public saveSMS(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, DIDData: any, callback: (err: any, data: any) => void) {
        const uuid = Str.random(30);
        let sdata = req.body;
        let FROM = "+1" + sdata.FROM.trim();
        let To = "+1" + sdata.TO.trim();
        let number_type = this.getType(sdata.TO);
        //let msg_data = sdata.BODY.replace(/"/g, '\\"').replace(/'/g, "\\'");
        let msg_data = sdata.BODY
        this.getRate(req, res, sessdata.idtariff, number_type, "SMS", (error, sms_rate) => {
            // To check MT Rates
            if (sms_rate || sessdata.isMobileVerify == "false" && sessdata.isEmailVerify == "true") {
                console.log("sms_rate::", sms_rate);
                let msgcount = Math.ceil((sdata.BODY.length) / 159);
                let cost = msgcount * (sms_rate[0].MT_rates + lerg_data[0].rates);
                let encsms = encodeURI(sdata.BODY);
                //encsms = encsms.replace(/"/g, '\\"').replace(/'/g, "\\'");
                let obj = new ModelRawNonQuery(req, res);
                obj.nonqrysql = "INSERT INTO `mdrlive` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`connection_key`,`sms_outbound_key`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`,`msg_count`,`cost`,`direction`,`did_provider`,`dca`,`campaignId`) VALUES('" + uuid + "','" + sdata.TO + "','" + sms_rate[0].MT_rates * msgcount + "','" + sdata.FROM + "','" + parseBody(msg_data) + "','dispatched','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + sdata.Connection + "','" + sdata.OutboundSMS + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + parseBody(lerg_data[0].co_name_spec_c) + "','" + setToZero(sessdata.idapi) + "','" + lerg_data[0].rates * msgcount + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + msgcount + "','" + cost + "','outbound','" + DIDData.DIDProvider + "','" + DIDData.SmsProvider + "','" + DIDData.campaignId + "')";;
                obj.prepare();
                obj.execute((error: any, responce: any) => {
                    if (error == 1) {
                        let obj = new ModelRawNonQuery(req, res);
                        obj.nonqrysql = "INSERT INTO `send_sms` (`sender`, `receiver`,`msgdata`,`time`,`smsc_id`,`dlr_mask`, `service`,`coding`) VALUES('" + FROM + "','" + To + "','" + parseBody(encsms) + "',UNIX_TIMESTAMP(),'" + DIDData.SmsProvider + "','11',"+setToZero(responce.insertId)+",'0');";
                        obj.prepare();
                        obj.execute((error: any, responce: any) => {
                            if (error == 1) {
                                let obj = new RawView(res);
                                obj.prepare({ status: 201, message: "SMS Submit Successfully", batch_id: uuid });
                                obj.execute()
                            }
                            else {
                                let obj = new RawView(res);
                                obj.prepare({ status: 501, message: "Something went wrong with sent SMS!" });
                                obj.execute()
                            }
                        })
                    }
                    else {
                        let obj = new RawView(res);
                        obj.prepare({ status: 502, message: "Something went wrong!" });
                        obj.execute()
                    }
                })
            }
            else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }

    public saveMMS(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, sms_provider: string, didData: any, fType: any, file: any, callback: (err: any, data: any) => void) {
        //let sdata = req.body;
        var sdata: any = req.body.data == undefined ? req.body : JSON.parse(req.body.data);
        let msg_data = "";
        if (sdata.BODY != null && sdata.BODY != undefined)
            //msg_data = sdata.BODY.replace(/"/g, '\\"').replace(/'/g, "\\'");
            msg_data = sdata.BODY
        let TO = sdata.TO.trim().slice(-10);
        let FROM = sdata.FROM.trim().slice(-10);


        let number_type = this.getType(TO);
        this.getRate(req, res, sessdata.idtariff, number_type, "MMS", (error, mms_rate) => {
            if (mms_rate) {
                let cost = (mms_rate[0].MT_rates + lerg_data[0].rates);
                var options = {
                    'method': 'POST',
                    'url': 'https://api.ci.mblox.com/ep/v2/',
                    'headers': {
                        'Content-Type': 'application/json',
                        'x-api-key': '4ZFnGzsQnEspkuOsUWxMHY5FSBaqmue0'
                    },
                    body: JSON.stringify({
                        "action": "sendMMS",
                        "service-id": didData.camp_registry,
                        "to": "1" + TO,
                        "from": "1" + FROM,
                        "from-mask": "1" + FROM,
                        "fallback-sms-text": "MMS",
                        "disable-fallback-sms-link": false,
                        "disable-fallback-sms": false,
                        "slide": fType
                    })
                };
                request(options, (error: any, response: any) => {
                    if (!error) {
                        try {
                            let dStatus: any = JSON.parse(response.body);
                            if (dStatus['status'] == 'success') {
                                let obj1 = new ModelRawNonQuery(req, res);
                                obj1.nonqrysql = "INSERT INTO `mms_dlr` (`idaccount`,`iduser`,`status`,`from`,`to`,`tracking_id`,`status_details`,`dca`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + dStatus['status'] + "','" + FROM + "','" + TO + "','" + dStatus['tracking-id'] + "','" + dStatus['status-details'] + "','" + didData.SmsProvider + "')";
                                obj1.prepare();
                                obj1.execute((errord: any, responced: any) => {
                                    if (errord == 1) {
                                        console.log("Sinch mms_dlr Data Inserted Successfully!");
                                    }
                                    else {
                                        console.log("Sinch mms_dlr Data Not Inserted Successfully!");
                                    }
                                });

                                let obj = new ModelRawNonQuery(req, res);
                                obj.nonqrysql = "INSERT INTO `mms_mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`, `slide`, `direction`,`dca`,`did_provider`,`service_id`,`cost`,`type`) VALUES('" + dStatus['tracking-id'] + "','" + TO + "','" + mms_rate[0].MT_rates + "','" + FROM + "','" + parseBody(msg_data) + "','3','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + file + "', 'outbound','" + didData.SmsProvider + "','" + didData.DIDProvider + "','" + didData.camp_registry + "','" + cost + "','2')";
                                obj.prepare();
                                obj.execute((error: any, responce: any) => {
                                    if (error == 1) {
                                        let obj = new RawView(res);
                                        obj.prepare({ status: 201, message: "MMS sent successfully", batch_id: dStatus['tracking-id'] });
                                        obj.execute()
                                    }
                                    else {
                                        let obj = new RawView(res);
                                        obj.prepare({ status: 502, message: "Something went wrong!" });
                                        obj.execute()
                                    }
                                });
                            }
                            else {
                                let obj = new ModelRawNonQuery(req, res);
                                obj.nonqrysql = "INSERT INTO `mms_mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`, `operator`, `slide`, `direction`,`dca`,`did_provider`,`service_id`,`cost`,`type`) VALUES('0','" + TO + "','" + mms_rate[0].MT_rates + "','" + FROM + "','" + parseBody(msg_data) + "','0','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + file + "','outbound','" + didData.SmsProvider + "','" + didData.DIDProvider + "','" + didData.camp_registry + "','0','2')";
                                obj.prepare();
                                obj.execute((error: any, responce: any) => {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 400, message: "MMS sent failed" });
                                    obj.execute()
                                });
                            }
                        }
                        catch (e) {
                            console.log("Error :: saveMMS Sinch::", e);
                            let obj = new RawView(res);
                            obj.prepare({ error_code: 0, status: 502, message: "Something went wrong!" });
                            obj.execute();
                        }
                    } else {
                        let objv = new RawView(res);
                        objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                        objv.execute();
                    }

                });
            } else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }
    getId() {
        return [
            { length: 3, maxBytes: 2 },
            { length: 3, maxBytes: 2 },
            { length: 3, maxBytes: 2 },
            { length: 14, maxBytes: 3 }
        ].reduce((prev, { length, maxBytes }) => {
            const bytes = Math.min(maxBytes, Math.ceil(length / 2));
            return prev + '-' + crypto.randomBytes(bytes).toString('hex').substr(0, length);
        }, crypto.randomBytes(2).toString('hex'));
    }

    public saveSynivMMS(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, sms_provider: string, didData: any, fType: any, file: any, file_path: any, callback: (err: any, data: any) => void) {
        //let sdata = req.body;
        //let uuid: any = this.getId();
        var sdata: any = req.body.data == undefined ? req.body : JSON.parse(req.body.data);
        let msg_data = "";
        if (sdata.BODY != null && sdata.BODY != undefined)
            // msg_data = sdata.BODY.replace(/"/g, '\\"').replace(/'/g, "\\'");
            msg_data = sdata.BODY
        let TO = sdata.TO.trim().slice(-10);
        let FROM = sdata.FROM.trim().slice(-10);
        let uuid: any = this.getId() + "-" + FROM;
        let number_type = this.getType(TO);
        this.getRate(req, res, sessdata.idtariff, number_type, "MMS", (error, mms_rate) => {
            if (mms_rate) {
                let cost = (mms_rate[0].MT_rates + lerg_data[0].rates);
                let rate = new APIBase();
                rate.checkBalance(req, res, sessdata.idaccount, cost, (errorR, resR) => {
                    if (errorR == 1) {
                        this.createFiles(req, res, file, file_path, msg_data, (errorr, fData) => {
                            if (errorr == 1 && fData) {
                                var options = {
                                    'method': 'POST',
                                    'url': 'http://10.128.0.13:3000/sendsyynivmms',
                                    // 'url': 'http://localhost:3000/sendsyynivmms',
                                    'headers': {
                                        'Content-Type': 'application/json',
                                        'Authorization': '4ZFdfjdWxMHY5FSBaqmue6847jbmbcjhds'
                                    },
                                    body: JSON.stringify({
                                        "to": "+1" + TO,
                                        "from": "+1" + FROM,
                                        "batch_id": uuid,
                                        "mms_body": msg_data,
                                        "attachment": fData.uploadPath,
                                        "attachmentwithurl": fData.urlPath,
                                        "smiltext": fData.smilFileText,
                                        "filename": fData.fileName
                                    })
                                };
                                request(options, (error: any, response: any) => {
                                    if (!error) {
                                        try {
                                            if (response.body !== undefined) {
                                                let result: any = JSON.parse(response.body)
                                                console.log("MMS API Response :: ", result);
                                                let send_status: any = '', status_detail: any = '', status_code: any = '', is_billable: any = 0;
                                                if (result.status == 201 || result.status == 405) {
                                                    // 3 success  // 5 resend
                                                    send_status = result.status == 201 ? 3 : 5;
                                                    status_detail = 'MMS Sent Successfully';
                                                    status_code = 201;
                                                    is_billable = 1;
                                                    // To Deduct MMS Sent Charges
                                                    let obj0 = new ModelRawNonQuery(req, res);
                                                    obj0.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + cost + " WHERE `idaccount`='" + sessdata.idaccount + "'"
                                                    obj0.prepare();
                                                    obj0.execute((wallet_error, wallet_success) => {
                                                        if (wallet_error == 1) {
                                                            console.log("Wallet amount successfully deducted for Syniv MMS Sent :: ", cost);
                                                        }
                                                        else {
                                                            console.log("Wallet amount not deducted for Syniv MMS Sent :: ", cost);
                                                        }
                                                    });
                                                    if (result.status == 201) {
                                                        let obj1 = new ModelRawNonQuery(req, res);
                                                        obj1.nonqrysql = "INSERT INTO `mms_dlr` (`idaccount`,`iduser`,`status`,`from`,`to`,`tracking_id`,`status_details`,`dca`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','success','" + FROM + "','" + TO + "','" + uuid + "','" + status_detail + "','" + sms_provider + "')";
                                                        obj1.prepare();
                                                        obj1.execute((errord: any, responced: any) => {
                                                            if (errord == 1) {
                                                                console.log("Syniv mms_dlr Data Inserted Successfully!");
                                                            }
                                                            else {
                                                                console.log("Syniv mms_dlr Data Not Inserted Successfully!");
                                                            }
                                                        });
                                                    }
                                                }
                                                else {
                                                    cost = 0
                                                    send_status = 0; // Failed
                                                    status_detail = 'MMS sent failed';
                                                    status_code = 400;
                                                    is_billable = 0;
                                                }
                                                let obj = new ModelRawNonQuery(req, res);
                                                obj.nonqrysql = "INSERT INTO `mms_mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`, `slide`,`direction`,`dca`,`did_provider`,`service_id`,`cost`,`type`,`message_accepted_by_signalmash`, `message_delivered_to_operator`, `delivery_receipt_received_by_singnalmash`, `delivery_receipt_delivered`,`is_billable`) VALUES('" + uuid + "','" + TO + "','" + mms_rate[0].MT_rates + "','" + FROM + "','" + parseBody(msg_data) + "','" + send_status + "','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + fData.urlPath + "','outbound','" + sms_provider + "','" + didData.DIDProvider + "','" + didData.camp_registry + "','" + cost + "','2',NOW(),NOW(),NOW(),NOW()," + is_billable + ")";
                                                obj.prepare();
                                                obj.execute((__error: any, responce: any) => {
                                                    if (__error == 1) {
                                                        let resData: any = result.status == 201 ? { status: status_code, message: status_detail, batch_id: uuid } : { status: status_code, message: status_detail }
                                                        let objv = new RawView(res);
                                                        objv.prepare(resData);
                                                        objv.execute()
                                                    }
                                                    else {
                                                        let objv = new RawView(res);
                                                        objv.prepare({ status: 401, message: "Something went wrong with MMS insertion" });
                                                        objv.execute()
                                                    }
                                                });
                                            }
                                            else {
                                                let objv = new RawView(res);
                                                objv.prepare({ status: 402, message: "MMS Sent Failed!" });
                                                objv.execute()
                                            }
                                        }
                                        catch (e) {
                                            console.log("Error :: saveSynivMMS::", e);
                                            let obj = new RawView(res);
                                            obj.prepare({ status: 403, message: "MMS Sent Failed!" });
                                            obj.execute();
                                        }
                                    }
                                    else {
                                        let objv = new RawView(res);
                                        objv.prepare({ status: 405, message: "MMS Sent Failed!" });
                                        objv.execute()
                                    }
                                })
                            }
                            else {
                                let objv = new RawView(res);
                                objv.prepare({ status: 503, message: "MMS Sent Failed!" });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView(res);
                        objv.prepare({ status: 504, message: "Please add funds to your account or contact support." });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }

    public saveSMS_Old(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, sms_provider: string, callback: (err: any, data: any) => void) {
        const uuid = Str.random(30);
        let sdata = req.body;
        let TO = "" + sdata.TO.trim() + "";
        let len = TO.length - 10;
        let FROM = "+1" + sdata.FROM.trim();
        let To = "+1" + sdata.TO.trim();
        let number_type = this.getType(sdata.TO);
        //let msg_data = sdata.BODY.replace(/"/g, '\\"').replace(/'/g, "\\'");
        let msg_data = sdata.BODY
        this.getRate(req, res, sessdata.idtariff, number_type, "SMS", (error, sms_rate) => {
            // To check MT Rates
            if (sms_rate || sessdata.isMobileVerify == "false" && sessdata.isEmailVerify == "true") {
                console.log("sms_rate::", sms_rate);
                let obj = new ModelRawNonQuery(req, res);
                obj.nonqrysql = "INSERT INTO `mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`connection_key`,`sms_outbound_key`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`) VALUES('" + uuid + "','" + sdata.TO + "','" + sms_rate[0].MT_rates + "','" + sdata.FROM + "','" + parseBody(msg_data) + "','dispatched','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + sdata.Connection + "','" + sdata.OutboundSMS + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + setToZero(sessdata.idapi) + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "')";
                obj.prepare();
                obj.execute((error: any, responce: any) => {
                    let encsms = encodeURI(sdata.BODY);
                    //encsms = encsms.replace(/"/g, '\\"').replace(/'/g, "\\'");
                    let obj = new ModelRawNonQuery(req, res);
                    obj.nonqrysql = "INSERT INTO `send_sms` (`sender`, `receiver`,`msgdata`,`time`,`smsc_id`,`dlr_mask`, `service`,`coding`) VALUES('" + FROM + "','" + To + "','" + parseBody(encsms) + "',UNIX_TIMESTAMP(),'" + sms_provider + "','11','" + responce.insertId + "','0')";
                    obj.prepare();
                    obj.execute((msg_err: any, msg_resp: any) => {
                        if (msg_err == 1 && msg_resp.insertId) {
                            let objv = new ModelRawQuery(req, res);
                            objv.qrysql = "SELECT `batch_id` FROM `mdr` WHERE `idmdr`='" + responce.insertId + "'";
                            objv.prepare();
                            objv.execute((mdr_err: any, mdr_resp: any) => {
                                if (mdr_err == 1 && mdr_resp.length > 0) {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 201, message: "SMS Submit Successfully", batch_id: mdr_resp[0].batch_id });
                                    obj.execute()
                                }
                                else {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 502, message: "Something went wrong!" });
                                    obj.execute()
                                }
                            })
                        }
                        else {
                            let obj = new RawView(res);
                            obj.prepare({ status: 502, message: "Something went wrong!" });
                            obj.execute()
                        }
                    })
                })
            }
            else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }
    public createFiles(req: Request, res: Response, fileUrl: any, filePathUplo: any, msg_data: any, callback: (err: any, data: any) => void) {

        let fName: any = path.basename(filePathUplo);
        let fNameP: any;
        const lastDotIndex = fName.lastIndexOf('.');
        fNameP = lastDotIndex === -1 ? fName : fName.substring(0, lastDotIndex);
        let upTextPath: any = '', urlTextPath: any;
        if (msg_data) {
            upTextPath = msg_data ? dir.MMSUPLOADS + '/' + fNameP + '.txt' : '';
            urlTextPath = msg_data ? dir.MMSMEDIAFILE + fNameP + '.txt' : '';
        }

        let mediaFiles: any = [
            filePathUplo,  // selected file path
            upTextPath // text file path

        ];

        let mediaUrlFiles: any = [
            fileUrl,     // selected file path
            urlTextPath // text file path
        ];

        function constructMediaElement(filePath: any, index: any) {
            const fileExtension = path.extname(filePath).toLowerCase();
            let mediaFileName = path.basename(filePath);
            switch (fileExtension) {
                //Image
                case '.bmp':
                case '.webp':
                case '.jpg':
                case '.jpeg':
                case '.png':
                case '.gif':
                    return [`<par dur="5s"><img src="${mediaFileName}" region="Image"></img></par>`,
                        `<region id="Image" height="100%" width="100%" fit="meet"></region>`];

                // Audio 
                case '.weba':
                case '.qcelp':
                case '.qcp':
                case '.xwav':
                case '.midi':
                case '.mid':
                case '.amr':
                case '.aac':
                case '.aacp':
                case '.mp3':
                case '.wav':
                    return [`<par dur="5s"><audio src="${mediaFileName}" region="Audio"></audio></par>`,
                        `<region id="Audio" height="100%" width="100%" fit="meet"></region>`];

                // Video 
                case '.h263':
                case '.h264':
                case '.jpgv':
                case '.3gp':
                case '.3g2':
                case '.mov':
                case '.mp4':
                case '.avi':
                    return [`<par dur="5s"><video src="${mediaFileName}" region="Video"></video></par>`,
                        `<region id="Video" height="100%" width="100%" fit="meet"></region>`];

                //Text
                case '.pdf':
                case '.vcf':
                case '.txt':
                case '.html':
                    return [`<par dur="5s"><text src="${mediaFileName}" region="Text"></text></par>`,
                        `<region id="Text" height="100%" width="100%" fit="scroll"></region>`];

                case '.gz':
                case '.rtf':
                case '.zip':
                    return [`<par dur="5s"><text src="${mediaFileName}" region="Application"></text></par>`,
                        `<region id="Application" height="100%" width="100%" fit="scroll"></region>`];
                default:
                    return '';
            }
        }

        const regionMedia = mediaFiles.map((filePath: any, index: any) => constructMediaElement(filePath, index)[0]);

        const region = mediaFiles.map((filePath: any, index: any) => constructMediaElement(filePath, index)[1]).sort((a: any, b: any) => b - a).reverse();

        //const region = mediaFiles.map((filePath: any, index: any) => constructMediaElement(filePath, index)[1]);

        const smilContent = `<smil><head><layout><root-layout/>${region}</layout></head><body>${regionMedia}</body></smil>`;

        let mediaAllFiles: any = [
            mediaFiles[0] !== undefined && mediaFiles[0] ? mediaFiles[0] : '' // file path            
        ];
        let mediaAllURLs: any = [
            mediaUrlFiles[0] !== undefined && mediaUrlFiles[0] ? mediaUrlFiles[0] : '' // file path  
        ];

        const allfiles = mediaAllFiles.filter((element: any) => element !== '');
        const uploadPath = allfiles.join(';');

        const fPathUp = mediaAllURLs.filter((element: any) => element !== '');
        const fPathUrl = fPathUp.join(';');

        callback(1, { uploadPath: uploadPath, urlPath: fPathUrl, smilFileText: smilContent.replace(/>(,)/g, '>'), fileName: fNameP });
    }

    public saveSCSMS(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, DIDData: any, callback: (err: any, data: any) => void) {
        const uuid = Str.random(30);
        let sdata = req.body;
        let FROM = "+1" + sdata.FROM.trim();
        let To = "+1" + sdata.TO.trim();
        let number_type = this.getType(sdata.TO);
        let msg_data = sdata.BODY;
        // let obj = new ModelRawQuery(req, res);
        // obj.qrysql = "SELECT IFNULL(`MT_rates`,0)`MT_rates` FROM `sms_rate` WHERE `id_tariff`=" + sessdata.idtariff + "  AND category='short_code' AND `subcategory`='SMS' LIMIT 1";
        // obj.prepare();
        // obj.execute((error: any, sms_rate: any) => {
        this.getRate(req, res, sessdata.idtariff, number_type, "SMS", (error, sms_rate) => {
            // To check MT Rates
            if (sms_rate || sessdata.isMobileVerify == "false" && sessdata.isEmailVerify == "true") {
                console.log("sms_rate::", sms_rate);
                let msgcount = Math.ceil((sdata.BODY.length) / 159);
                let cost = msgcount * (sms_rate[0].MT_rates + lerg_data[0].rates);
                let encsms = encodeURI(sdata.BODY);
                //encsms = encsms.replace(/"/g, '\\"').replace(/'/g, "\\'");
                let iQry: string = "INSERT INTO `mdrlive` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`connection_key`,`sms_outbound_key`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`,`msg_count`,`cost`,`direction`,`did_provider`,`dca`,`campaignId`) VALUES('" + uuid + "','" + sdata.TO + "','" + sms_rate[0].MT_rates * msgcount + "','" + sdata.FROM + "','" + parseBody(msg_data) + "','dispatched','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + sdata.Connection + "','" + sdata.OutboundSMS + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + parseBody(lerg_data[0].co_name_spec_c) + "','" + setToZero(sessdata.idapi) + "','" + lerg_data[0].rates * msgcount + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + msgcount + "','" + cost + "','outbound','" + DIDData.DIDProvider + "','" + DIDData.SmsProvider + "','" + DIDData.campaignId + "');\n"

                iQry += "INSERT INTO `send_sms` (`sender`, `receiver`,`msgdata`,`time`,`smsc_id`,`dlr_mask`, `service`,`coding`) VALUES('" + FROM + "','" + To + "','" + parseBody(encsms) + "',UNIX_TIMESTAMP(),'" + DIDData.SmsProvider + "','11',LAST_INSERT_ID(),'0');"

                let obj = new ModelRawNonQuery(req, res);
                obj.nonqrysql = iQry;
                obj.prepare();
                obj.execute((error: any, responce: any) => {
                    if (error == 1) {
                        let obj = new RawView(res);
                        obj.prepare({ status: 201, message: "SMS Sent Successfully", batch_id: uuid });
                        obj.execute()
                    }
                    else {
                        let obj = new RawView(res);
                        obj.prepare({ status: 502, message: "Something went wrong!" });
                        obj.execute()
                    }
                })
            }
            else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }

    public saveSCMMS(req: Request, res: Response, next: NextFunction, sessdata: any, lerg_data: any, sms_provider: string, didData: any, fType: any, file: any, callback: (err: any, data: any) => void) {
        var sdata: any = req.body.data == undefined ? req.body : JSON.parse(req.body.data);
        let msg_data = "";
        if (sdata.BODY != null && sdata.BODY != undefined)
            msg_data = sdata.BODY
        let TO = sdata.TO.trim().slice(-10);
        let FROM = sdata.FROM.trim().slice(-10);
        let number_type = this.getType(TO);
        // let obj = new ModelRawQuery(req, res);
        // obj.qrysql = "SELECT IFNULL(`MT_rates`,0)`MT_rates` FROM `sms_rate` WHERE `id_tariff`=" + sessdata.idtariff + "  AND category='short_code' AND `subcategory`='MMS' LIMIT 1";
        // obj.prepare();
        // obj.execute((error: any, mms_rate: any) => {
        this.getRate(req, res, sessdata.idtariff, number_type, "MMS", (error, mms_rate) => {
            if (mms_rate) {
                let cost = (mms_rate[0].MT_rates + lerg_data[0].rates);
                var options = {
                    'method': 'POST',
                    'url': 'https://api.ci.mblox.com/ep/v2/',
                    'headers': {
                        'Content-Type': 'application/json',
                        'x-api-key': '4ZFnGzsQnEspkuOsUWxMHY5FSBaqmue0'
                    },
                    body: JSON.stringify({
                        "action": "sendMMS",
                        "service-id": didData.camp_registry,
                        "to": "1" + TO,
                        "from": "1" + FROM,
                        "from-mask": "1" + FROM,
                        "fallback-sms-text": "MMS",
                        "disable-fallback-sms-link": false,
                        "disable-fallback-sms": false,
                        "slide": fType
                    })
                };
                request(options, (error: any, response: any) => {
                    if (!error) {
                        try {
                            let dStatus: any = JSON.parse(response.body);
                            if (dStatus['status'] == 'success') {
                                let obj1 = new ModelRawNonQuery(req, res);
                                obj1.nonqrysql = "INSERT INTO `mms_dlr` (`idaccount`,`iduser`,`status`,`from`,`to`,`tracking_id`,`status_details`,`dca`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + dStatus['status'] + "','" + FROM + "','" + TO + "','" + dStatus['tracking-id'] + "','" + dStatus['status-details'] + "','" + didData.SmsProvider + "')";
                                obj1.prepare();
                                obj1.execute((errord: any, responced: any) => {
                                    if (errord == 1) {
                                        console.log("Sinch mms_dlr Data Inserted Successfully!");
                                    }
                                    else {
                                        console.log("Sinch mms_dlr Data Not Inserted Successfully!");
                                    }
                                });

                                let obj = new ModelRawNonQuery(req, res);
                                obj.nonqrysql = "INSERT INTO `mms_mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`,`operator`, `slide`, `direction`,`dca`,`did_provider`,`service_id`,`cost`,`type`) VALUES('" + dStatus['tracking-id'] + "','" + TO + "','" + mms_rate[0].MT_rates + "','" + FROM + "','" + parseBody(msg_data) + "','3','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + file + "', 'outbound','" + didData.SmsProvider + "','" + didData.DIDProvider + "','" + didData.camp_registry + "','" + cost + "','2')";
                                obj.prepare();
                                obj.execute((error: any, responce: any) => {
                                    if (error == 1) {
                                        let obj = new RawView(res);
                                        obj.prepare({ status: 201, message: "MMS sent successfully", batch_id: dStatus['tracking-id'] });
                                        obj.execute()
                                    }
                                    else {
                                        let obj = new RawView(res);
                                        obj.prepare({ status: 502, message: "Something went wrong!" });
                                        obj.execute()
                                    }
                                });
                            }
                            else {
                                let obj = new ModelRawNonQuery(req, res);
                                obj.nonqrysql = "INSERT INTO `mms_mdr` (`batch_id`, `to_number`, `MT_rates`,`from_number`, `messsage_body`,`status`,`npa`,`state`,`idaccount`,`iduser`,`number_type`,`ocn`,`lata`,`category`,`mobility`,`idapi`,`MT_surcharge`,`idoperator`, `operator`, `slide`, `direction`,`dca`,`did_provider`,`service_id`,`cost`,`type`) VALUES('0','" + TO + "','" + mms_rate[0].MT_rates + "','" + FROM + "','" + parseBody(msg_data) + "','0','" + lerg_data[0].npa + "','" + lerg_data[0].state + "','" + sessdata.idaccount + "','" + sessdata.iduser + "','" + number_type + "','" + lerg_data[0].ocn + "','" + lerg_data[0].lata + "','" + lerg_data[0].category + "','" + lerg_data[0].co_name_spec_c + "','" + sessdata.idapi + "','" + lerg_data[0].rates + "','" + lerg_data[0].idoperator + "','" + lerg_data[0].name + "','" + file + "','outbound','" + didData.SmsProvider + "','" + didData.DIDProvider + "','" + didData.camp_registry + "','0','2')";
                                obj.prepare();
                                obj.execute((error: any, responce: any) => {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 400, message: "MMS sent failed" });
                                    obj.execute()
                                });
                            }
                        }
                        catch (e) {
                            console.log("Error :: saveMMS Sinch::", e);
                            let obj = new RawView(res);
                            obj.prepare({ error_code: 0, status: 502, message: "Something went wrong!" });
                            obj.execute();
                        }
                    } else {
                        let objv = new RawView(res);
                        objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                        objv.execute();
                    }

                });
            } else {
                let objv = new RawView(res);
                objv.prepare({ result: "MT Rates Not Found!", status: 502 });
                objv.execute();
            }
        })
    }

    // backup
    /* public createFiles(req: Request, res: Response, fileUrl: any, filePathUplo: any, msg_data: any, callback: (err: any, data: any) => void) {

        let fName: any = path.basename(filePathUplo);
        let fNameP: any;
        const lastDotIndex = fName.lastIndexOf('.');
        fNameP = lastDotIndex === -1 ? fName : fName.substring(0, lastDotIndex);

        let upTextPath: any = '', urlTextPath: any;
        if (msg_data) {

            upTextPath = msg_data ? dir.MMSUPLOADS + '/' + fNameP + '.txt' : '';
            urlTextPath = msg_data ? dir.MMSMEDIAFILE + fNameP + '.txt' : '';

            fs.writeFile(upTextPath, msg_data, err => {
                err ? console.error('Error Text creating file:', err) : console.log('Text File created successfully:', upTextPath)
            });
        }

        let mediaFiles: any = [
            upTextPath, // text file path
            filePathUplo,  // selected file path
        ];

        let mediaUrlFiles: any = [
            urlTextPath, // text file path
            fileUrl,  // selected file path
        ];

        function constructMediaElement(filePath: any, index: any) {
            const fileExtension = path.extname(filePath).toLowerCase();
            switch (fileExtension) {
                case '.jpg':
                case '.jpeg':
                case '.png':
                case '.gif':
                    return [`<par dur="5s"><img src="cid:${fNameP}" region="Image"></img></par>`,
                        `<region id="Image" height="100%" width="100%" fit="meet"></region>`];
                case '.mp3':
                case '.wav':
                    return [`<par dur="5s"><audio src="cid:${fNameP}" region="Audio"></audio></par>`,
                        `<region id="Audio" height="100%" width="100%" fit="meet"></region>`];
                case '.mp4':
                case '.avi':
                    return [`<par dur="5s"><video src="cid:${fNameP}" region="Video"></video></par>`,
                        `<region id="Video" height="100%" width="100%" fit="meet"></region>`];
                case '.pdf':
                case '.txt':
                case '.html':
                    return [`<par dur="5s"><text src="cid:${fNameP}" region="Text"><text/></par>`,
                        `<region id="Text" height="100%" width="100%" fit="scroll"></region>`];
                default:
                    return '';
            }
        }

        const region = mediaFiles.map((filePath: any, index: any) => constructMediaElement(filePath, index)[0]).join('\n');
        const regionMedia = mediaFiles.map((filePath: any, index: any) => constructMediaElement(filePath, index)[1]).join('\n');

        const smilContent = `<smil>
        <head>
        <layout>
            <root-layout/>
            ${region}
        </layout>
        </head>
        <body>
            ${regionMedia}
        </body>
        </smil>`;

        let smilUpPath: any = dir.MMSUPLOADS + '/' + fNameP + '.smil';
        let smilURLPath: any = dir.MMSMEDIAFILE + fNameP + '.smil';
        fs.writeFile(smilUpPath, smilContent, err => {
            err ? console.error('Error SMIL file:', err) : console.log('SMIL file created successfully:', smilUpPath)
        });

        let mediaAllFiles: any = [
            smilUpPath, // smil path
            mediaFiles[0] !== undefined && mediaFiles[0] ? mediaFiles[0] : '', // text path
            mediaFiles[1] !== undefined && mediaFiles[1] ? mediaFiles[1] : '', // file path            
        ];
        let mediaAllURLs: any = [
            smilURLPath, // smil path
            mediaUrlFiles[0] !== undefined && mediaUrlFiles[0] ? mediaUrlFiles[0] : '', // text path
            mediaUrlFiles[1] !== undefined && mediaUrlFiles[1] ? mediaUrlFiles[1] : '', // file path  
        ];

        const allfiles = mediaAllFiles.filter((element: any) => element !== '');
        const uploadPath = allfiles.join(';');

        const fPathUp = mediaAllURLs.filter((element: any) => element !== '');
        const fPathUrl = fPathUp.join(';');

        callback(1, { uploadPath: uploadPath, urlPath: fPathUrl });
    } */

    public abstract SendSms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendMms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendSynivMms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendTFSms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendTFMms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendSCSms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
    public abstract SendSCMms(req: Request, res: Response, next: NextFunction, data: any, sms_provider: string, callback: (err: any, data: any) => void): void;
}
