import { APIBase } from "./APIBase";
import { Request, Response, NextFunction } from "express";
import { ModelRawNonQuery } from "../lib/model/RawNonQuery";
import { ModelRawQuery } from "../lib/model/RawQuery";
import { RawView } from "../lib/view/RawView";
import { OsrApi } from "./Osr";
import { SinchApi } from "./SinchSubmitNumber";
import { Number } from "./numberApi";
import { parseBody, setToZero } from "./markError";
var request = require('request');
var convert = require('xml-js');

export class PeerlessAPI extends APIBase {
    private url: string;
    private customer: string;
    private passCode: string;
    private userId: string;
    private soapenv: string;
    private pub: string;
    private key: string;
    private secret: string;
    private priority: string;
    private sessdata: any;
    private timekey: string;

    constructor(proirity: string, sessdata: string, timekey: string) {
        super();

        /* Staging Details */
        this.customer = "TRAYTECKdba";
        this.passCode = "F6EBSVEJ";
        this.userId = "jeremy.kelley_stg@iplinktelecom.com";
        this.soapenv = "http://schemas.xmlsoap.org/soap/envelope/";
        this.pub = "http://publicapi.api.s2.peerless.com/";
        this.url = "https://aniweb02.peerlessnetwork.com:8181/public/APIService?wsdl";

        /* Production Details */
        /*this.customer = "TrayteckLLC";
        this.passCode = "0JURS5TZ";
        this.userId = "api@iplinktelecom.com";

        this.soapenv = "http://schemas.xmlsoap.org/soap/envelope/";
        this.pub = "http://publicapi.api.s2.peerless.com/";
        this.url = "https://animate.peerlessnetwork.com:8181/public/APIService?wsdl"; */

        this.priority = proirity;
        this.key = "";
        this.secret = "";
        this.timekey = timekey,
            this.sessdata = sessdata;
    }

    public getNpaNxx(req: Request, res: Response, callback: (err: any, data: any) => void): void {
        if (this.priority == "100") {
            callback('', '');
        } else {
            this.getRate(req, res, this.sessdata.idtariff, "message", "NN", (err, voice_rate) => {
                let condition: any = "";
                if (req.query.NPA && (req.query.NXX == '' || req.query.NXX == 'null')) {
                    condition = '<npas><npa>' + req.query.NPA + '</npa></npas>';
                } else if (req.query.NPA && req.query.NXX) {
                    condition = '<npas><npa>' + req.query.NPA + '</npa></npas><nxxs><nxx>' + req.query.NXX + '</nxx></nxxs>';
                }
                const qty = req.query.Qty;

                let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:searchNumbers><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><filters>' + condition + '<quantity>' + qty + '</quantity><consecutive>1</consecutive><vanityDigits>?</vanityDigits><categories><category>1</category><category>2</category></categories><selectedTN><tn>?</tn></selectedTN></filters></pub:searchNumbers></soapenv:Body></soapenv:Envelope>';

                let options: any = {
                    'method': 'POST',
                    'url': this.url,
                    'body': data,
                    'headers': {
                        'Content-Type': 'text/xml',
                        'SOAPAction': 'searchNumbers'
                    },
                };
                request(options, (error: any, response: any, body: any) => {
                    if (!error) {
                        try {
                            if (body) {
                                let tmp: string = body;
                                var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                var res1 = JSON.parse(result1);
                                let check = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["tnCount"];
                                if (check._text > '0') {
                                    let ddata = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["result"]["tn"];
                                    if (!ddata.length) { ddata = [ddata] }
                                    if (ddata !== undefined && ddata.length > 0) {
                                        let str: any = ddata;
                                        let obj1 = new ModelRawNonQuery(req, res);
                                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`,`iduser`,`idaccount`, `priorty`,`key`,`type`,`rates`) VALUE ";
                                        str.forEach((ele: any) => {
                                            qrystr += "('','" + ele.number._text + "','', '', '', '', '', '', '' ,'" + "Peerless" + "','" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '" + this.priority + "','" + this.timekey + "','NN','" + voice_rate[0].rate + "'),";
                                        });
                                        obj1.nonqrysql = qrystr.slice(0, -1);
                                        obj1.prepare();
                                        obj1.execute((err, data) => {
                                            callback(err, data);
                                        });
                                    } else {
                                        callback('', ddata);
                                    }
                                } else {
                                    callback('', error);
                                }
                            } else {
                                callback('', error);
                            }
                        } catch (e) {
                            console.log("Error :: Peerless->getNpaNxx::", e);
                            callback('', error);
                        }
                    } else {
                        callback('', error);
                    }
                });
            });
        }
    }

    public getByRate(req: Request, res: Response, callback: (err: any, data: any) => void) {
        if (this.priority == "100") {
            callback('', '');
        } else {
            this.getRate(req, res, this.sessdata.idtariff, "message", "NN", (err, voice_rate) => {
                if (err == 1 && voice_rate.length > 0) {
                    const state = req.query.State
                    const rate_center = req.query.RateCenter;
                    const qty = req.query.Qty;

                    let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:searchNumbers><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><filters><states><state>' + state + '</state></states><rateCenters><rateCenter>' + rate_center + '</rateCenter></rateCenters><quantity>' + qty + '</quantity><consecutive>1</consecutive><vanityDigits>?</vanityDigits><categories><category>1</category><category>2</category></categories><selectedTN><tn>?</tn></selectedTN></filters></pub:searchNumbers></soapenv:Body></soapenv:Envelope>';

                    let options: any = {
                        'method': 'POST',
                        'url': this.url,
                        'body': data,
                        'headers': {
                            'Content-Type': 'text/xml',
                            'SOAPAction': 'searchNumbers'
                        },
                    };
                    request(options, (error: any, response: any, body: any) => {
                        if (!error) {
                            try {
                                let tmp: string = body;
                                var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                var res1 = JSON.parse(result1);
                                var check = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["tnCount"];
                                if (check._text > '0') {
                                    var ddata = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["result"]["tn"];
                                    if (!ddata.length) { ddata = [ddata] }
                                    let rateCenter = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["rateCenters"]["rateCenter"]["_text"];
                                    let state = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["states"]["state"]["_text"];
                                    if (ddata !== undefined && ddata.length > 0) {
                                        let str: any = ddata;
                                        let obj1 = new ModelRawNonQuery(req, res);
                                        let qrystr = "INSERT INTO `did_search` (`iduser`,`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`,`key`,`type`,`rates`) VALUE ";
                                        str.forEach((ele: any) => {
                                            qrystr += "('" + this.sessdata.iduser + "', '','" + ele.number._text + "', '', '', '" + rateCenter + "','" + parseBody(state) + "', '', '', '','" + "Peerless" + "', '" + this.sessdata.idaccount + "', '" + this.priority + "','" + this.timekey + "','NN','" + voice_rate[0].rate + "'),";
                                        });
                                        obj1.nonqrysql = qrystr.slice(0, -1);
                                        obj1.prepare();
                                        obj1.execute((err, data) => {
                                            callback(err, data);
                                        });
                                    } else {
                                        callback('', ddata);
                                    }
                                } else {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 502, message: "No DID Found!" });
                                    obj.execute()
                                }
                            }
                            catch (e) {
                                console.log("Error :: Peerless->getByRate::", e);
                                callback('', error);
                            }

                        } else {
                            callback('', error);
                        }
                    });
                } else {
                    callback(err, voice_rate);
                }
            });
        }
    }

    public getTollFree(req: Request, res: Response, callback: (err: any, data: any) => void) {
        if (this.priority == "100") {
            callback('', '');
        } else {
            const tollfree = req.query.TF_PREFIX
            const qty = req.query.Qty;

            /** For testing purpose */
            this.getRate(req, res, this.sessdata.idtariff, "message", "NN", (err, voice_rate) => {
                let condition: any = "";
                condition = '<npas><npa>' + tollfree + '</npa></npas>';
                const qty = req.query.Qty;

                let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:searchNumbers><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><filters>' + condition + '<quantity>' + qty + '</quantity><consecutive>1</consecutive><vanityDigits>?</vanityDigits><categories><category>1</category><category>2</category></categories><selectedTN><tn>?</tn></selectedTN></filters></pub:searchNumbers></soapenv:Body></soapenv:Envelope>';

                let options: any = {
                    'method': 'POST',
                    'url': this.url,
                    'body': data,
                    'headers': {
                        'Content-Type': 'text/xml',
                        'SOAPAction': 'searchNumbers'
                    },
                };
                request(options, (error: any, response: any, body: any) => {
                    if (!error) {
                        try {
                            if (body) {
                                let tmp: string = body;
                                var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                var res1 = JSON.parse(result1);
                                let check = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["tnCount"];
                                if (check._text > '0') {
                                    let ddata = res1["S:Envelope"]["S:Body"]["ns2:searchNumbersResponse"]["return"]["result"]["tn"];
                                    if (!ddata.length) { ddata = [ddata] }
                                    if (ddata !== undefined && ddata.length > 0) {
                                        let str: any = ddata;
                                        let obj1 = new ModelRawNonQuery(req, res);
                                        let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`,`iduser`,`idaccount`, `priorty`,`key`,`type`,`rates`) VALUE ";
                                        str.forEach((ele: any) => {
                                            qrystr += "('','" + ele.number._text + "','', '', '', '', '', '', '' ,'" + "Peerless" + "','" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '" + this.priority + "','" + this.timekey + "','TF','" + voice_rate[0].rate + "'),";
                                        });
                                        obj1.nonqrysql = qrystr.slice(0, -1);
                                        obj1.prepare();
                                        obj1.execute((err, data) => {
                                            callback(err, data);
                                        });
                                    } else {
                                        callback('', ddata);
                                    }
                                } else {
                                    let obj = new RawView(res);
                                    obj.prepare({ status: 502, message: "No DID Found!" });
                                    obj.execute()
                                }
                            } else {
                                callback('', error);
                            }
                        }
                        catch (e) {
                            console.log("Error :: Peerless->getTollFree::", e);
                            callback('', error);
                        }
                    }
                    else {
                        let obj = new RawView(res);
                        obj.prepare({ status: 502, message: "No DID Found!" });
                        obj.execute()
                    }

                });

            });


            // let options: any = {
            //     'method': 'POST',
            //     'url': 'https://devapi.coretel.net/cgi-bin/xmlnumberdb.pl',
            //     'body': "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?><RequestType>VanitySearch</RequestType><Purpose>SIP</Purpose><Quantity>" + qty + "</Quantity><Tollfree>" + tollfree + "</Tollfree><BillingAccount>" + this.key + "</BillingAccount><Password>" + this.secret + "</Password></xml>",
            //     rejectUnauthorized: false,
            //     requestCert: true,
            //     agent: false
            // };
            // console.log("Peerless Http::", options)
            // request(options, (error: any, response: any, body: any) => {
            //     console.log("Peerless::\n", body)
            //     if (!error) {
            //         let tmp: string = body;
            //         let valid_xml = tmp.slice(0, -6)
            //         console.log(valid_xml);
            //         var result1 = convert.xml2json(valid_xml, { compact: true, spaces: 4 });
            //         var res1 = JSON.parse(result1);
            //         let ddata = res1.xml.SearchResult;
            //         console.log("Data==>", ddata);
            //         if (ddata !== undefined && ddata.length > 0) {
            //             let str: any = ddata;
            //             let obj1 = new ModelRawNonQuery(req, res);
            //             let qrystr = "INSERT INTO `did_search` (`friendly_name`, `phone_number`, `lata`, `locality`, `rate_center`, `state`, `postal_code`, `capabilities` ,`city`, `provider`, `idaccount`, `priorty`, `type`) VALUE ";
            //             str.forEach((ele: any) => {
            //                 console.log(ele.Number._text);
            //                 qrystr += "('','" + ele.Number._text + "', '', '', '" + ele.RateCenter._text + "', '', '', '', '' ,'" + "coreTel" + "', '" + this.sessdata.idaccount + "', '" + this.priority + "', 'TF'),";
            //             });
            //             obj1.nonqrysql = qrystr.slice(0, -1);
            //             obj1.prepare();
            //             obj1.execute((err, data) => {
            //                 callback(err, data);
            //             });
            //         } else {
            //             callback('', ddata);
            //         }
            //     } else {
            //         callback('', error);
            //     }
            // });
        }
    }

    public buyDID(req: Request, res: Response, did_details: any, other_data: any, callback: (err: any, data: any) => void) {
        const sdata = req.body;
        let did = sdata.DID.trim();
        let len = did.length - 10;
        let npa = did.slice(len, len + 3);
        let nxx = did.slice(len + 3, len + 6)
        let id_grouporder: number = other_data.id_grouporder;
        let sub_type: number = other_data.sub_type;

        this.getRateCenter(req, res, npa, nxx, (err, ratecenter_state) => {
            let ratecenter = ratecenter_state[0] !== undefined ? ratecenter_state[0].rc_abbre : ''
            let state = ratecenter_state[0] !== undefined ? ratecenter_state[0].loc_state : ''

            // To get the proration status
            let objv0 = new ModelRawQuery(req, res);
            objv0.qrysql = "SELECT t.`proration`,t.`day_num` FROM `user`u JOIN `tariff`t ON u.idtariff=t.idtariff WHERE iduser= '" + this.sessdata.iduser + "'";
            objv0.prepare();
            objv0.execute((proration_error, proration_success) => {
                if (proration_error == 1) {
                    let proration_status = proration_success[0].proration;
                    let did_dis_days = proration_success[0].day_num > 0 ? proration_success[0].day_num : 0;
                    // To purchase the toll-free number
                    if (did_details[0].type == "TF") {
                        let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:placeTFOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><TFNOrder><orderType>TF</orderType><respOrgId>PNN01</respOrgId><defaultAos>US</defaultAos><defaultDestination>TF_TTTF_02</defaultDestination><defaultPayPhoneBlocking>1</defaultPayPhoneBlocking><tollFreeOrderNumbers><tollFreeOrderNumbers><tn>' + sdata.DID.trim() + '</tn><aos>US</aos><destination>TF_TTTF_02</destination><cnamDelivery>true</cnamDelivery><payPhoneBlocking>true</payPhoneBlocking></tollFreeOrderNumbers></tollFreeOrderNumbers></TFNOrder></pub:placeTFOrder></soapenv:Body></soapenv:Envelope>';

                        let options: any = {
                            'method': 'POST',
                            'url': this.url,
                            'headers': {
                                'Content-Type': 'text/xml',
                                'SOAPAction': 'placeTFOrder'
                            },
                            body: data,
                        };
                        request(options, (error: any, response: any, body: any) => {
                            if (!error) {
                                try {
                                    let tmp = body;
                                    var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 })
                                    let res1 = JSON.parse(result1)
                                    // If order placed successfully
                                    if (typeof res1["S:Envelope"]["S:Body"]["ns2:placeTFOrderResponse"] != 'undefined') {
                                        let providerOrderId: any = typeof res1["S:Envelope"]["S:Body"]["ns2:placeTFOrderResponse"]["return"] != 'undefined' && res1["S:Envelope"]["S:Body"]["ns2:placeTFOrderResponse"]["return"]["_text"] ? res1["S:Envelope"]["S:Body"]["ns2:placeTFOrderResponse"]["return"]["_text"] : ''

                                        let order: any = providerOrderId
                                        let dateObj = new Date();
                                        let day = dateObj.getUTCDate();

                                        let nDate: any = new Date()
                                        let lDate: any = (new Date(nDate.getFullYear(), (nDate.getMonth() + 1), 0)).getDate()
                                        let totalDays = (lDate - day) + 1;

                                        let prorate: any;
                                        if (proration_status == "true") {
                                            prorate = (totalDays * did_details[0].rates) / lDate;
                                        }
                                        else {
                                            prorate = did_details[0].rates;
                                        }
                                        prorate = typeof prorate != 'undefined' && prorate > 0 ? prorate : 0

                                        let obj = new ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`,`pro_rates`,`did_disconnect_days`,`nrc_rates`,`did_sub_type`) VALUE('" + this.sessdata.idaccount + "','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','TF','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + setToZero(this.sessdata.idapi) + "','" + prorate + "','" + did_dis_days + "','" + did_details[0].rates + "','" + sub_type + "')";
                                        obj.prepare();
                                        obj.execute((err, data) => {
                                            if (err == 1) {
                                                // update end subscription date
                                                let obj0 = new ModelRawQuery(req, res);
                                                obj0.qrysql = "SELECT d.iddid, d.iduser, d.account_id, d.user_id,IF(DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY) >NOW(),DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY),LAST_DAY(NOW()))AS subscription_end_date,DATE_FORMAT(d.`created_at`,'%Y-%m-%d %H:%i:%s')`created_at` FROM `did_buy`d LEFT JOIN `endpoint`e ON d.connection_key = e.connection_key INNER JOIN  `user`u ON d.iduser=u.iduser INNER JOIN `tariff` t ON t.idtariff=u.idtariff WHERE d.iddid='" + data.insertId + "' AND disconnect_did_status = '1'";
                                                obj0.prepare();
                                                obj0.execute((dids_err, didRes) => {
                                                    let dates = didRes[0].subscription_end_date;
                                                    let isoDate = new Date(dates);
                                                    let subscriptionEndDate = isoDate.toJSON().slice(0, 19).replace('T', ' ');
                                                    let obj01 = new ModelRawNonQuery(req, res);
                                                    obj01.nonqrysql = "UPDATE `did_buy` SET `subscription_end_date`='" + subscriptionEndDate + "' WHERE `iddid`=" + didRes[0].iddid + ";"
                                                    obj01.prepare();
                                                    obj01.execute((error, result) => { })
                                                })

                                                let objv = new ModelRawNonQuery(req, res);
                                                objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'"
                                                objv.prepare();
                                                objv.execute((wallet_error, wallet_success) => {

                                                    // To update the wallet transaction log
                                                    let iQry: string = "INSERT INTO `wallet_recharge_log` SET "
                                                    iQry += "`idaccount`=" + this.sessdata.idaccount + ", "
                                                    iQry += "`amount`='-" + prorate + "', "
                                                    iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', "
                                                    iQry += "`status`=1;"

                                                    let objWL = new ModelRawNonQuery(req, res);
                                                    objWL.nonqrysql = iQry
                                                    objWL.prepare()
                                                    objWL.execute((error: any, result: any) => {
                                                    })

                                                    // To create the DID log
                                                    let objv1 = new ModelRawNonQuery(req, res);
                                                    objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`,`event_type`,`description`,`full_log`) VALUE('" + this.sessdata.idaccount + "','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','TF','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "','1','DID Buy','" + res1 + "')";
                                                    objv1.prepare();
                                                    objv1.execute((log_error, did_log) => { });

                                                    // To delete the DID from cart
                                                    let obj5 = new ModelRawNonQuery(req, res);
                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'"
                                                    obj5.prepare();
                                                    obj5.execute((walletError: any, wallet: any) => { });

                                                    // To update the process count of group order
                                                    let objk = new ModelRawNonQuery(req, res)
                                                    objk.nonqrysql = "UPDATE `did_group_order` SET `process_dids`=`process_dids`+ 1 WHERE `id_grouporder`=" + id_grouporder + ";"
                                                    objk.prepare()
                                                    objk.execute((error, result) => {
                                                        console.log("GroupOrder process count::\n", result)
                                                    })

                                                    // To create the did_order
                                                    let obj = new ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '201', '" + sdata.DID + "', '2', 'TF', '" + did_details[0].rates + "', 'Order successfully created.', " + id_grouporder + ", 1)";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        // To update the other data on current order
                                                        if (did_err == 1) {
                                                            let id_order: number = did_data.insertId
                                                            let orderID: string = "SORD" + id_order.toString()

                                                            let log_error: string = ""
                                                            let log_message: string = "Order successfully created."
                                                            let log_result: string = JSON.stringify(res1).replace(/'/g, "\\'").replace(/"/g, '\\"')

                                                            obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='200', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=0, `provider`='Peerless', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";"
                                                            obj.prepare();
                                                            obj.execute((error, result) => { })
                                                        }

                                                        let objV = new RawView(res);
                                                        objV.prepare({
                                                            error_code: 1,
                                                            status: 201,
                                                            message: "DID buy successfully.",
                                                            result: [
                                                                {
                                                                    "did": did
                                                                }
                                                            ]
                                                        });
                                                        objV.execute()
                                                    });
                                                });
                                            }
                                            else {
                                                let obj = new RawView(res);
                                                obj.prepare({
                                                    error_code: 0,
                                                    status: 502,
                                                    message: "Something went wrong with connection!"
                                                });
                                                obj.execute()
                                            }
                                        });
                                    }

                                    // If order failed
                                    else if (typeof res1["S:Envelope"]["S:Body"]["S:Fault"] != 'undefined') {
                                        let Fault: any = res1["S:Envelope"]["S:Body"]["S:Fault"]

                                        let providerOrderId: any = ''

                                        let obj = new ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`, `error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '501', '" + did + "', '4', 'TF', '" + did_details[0].rates + "', 'Order creation failed!', " + id_grouporder + ", 1)";
                                        obj.prepare();
                                        obj.execute((did_err, did_data) => {
                                            // To update the other data on current order
                                            if (did_err == 1) {
                                                let id_order: number = did_data.insertId
                                                let orderID: string = "SORD" + id_order.toString()

                                                let log_error: string = JSON.stringify(res1).replace(/'/g, "\\'").replace(/"/g, '\\"')
                                                let log_message: string = (Fault['faultcode'] + ' - ' + Fault['faultstring']).replace(/'/g, "\\'").replace(/"/g, '\\"')
                                                let log_result: string = ""

                                                obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='501', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=1, `provider`='Peerless', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";"
                                                obj.prepare();
                                                obj.execute((error, result) => { })
                                            }
                                        });

                                        let objn = new ModelRawNonQuery(req, res);
                                        objn.nonqrysql = "INSERT INTO `did_log`(`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + this.sessdata.iduser + "',NOW(),'40','DID Buy failed from provider','" + sdata.DID.trim() + "','" + res1 + "')"
                                        objn.prepare();
                                        objn.execute((errorDiDLg: any, resDiDLg: any) => {
                                            console.log("DID Buy failed from provider");
                                        });

                                        let objV = new RawView(res);
                                        objV.prepare({
                                            error_code: 0,
                                            status: 502,
                                            message: Fault['faultstring'],
                                            error: Fault['faultcode'] + ' - ' + Fault['faultstring']
                                        });
                                        objV.execute();
                                    }
                                    else {
                                        let obj = new RawView(res);
                                        obj.prepare({
                                            error_code: 0,
                                            status: 502,
                                            message: "Something Went Wrong"
                                        });
                                        obj.execute()
                                    }
                                }
                                catch (e) {
                                    console.log("Error :: Peerless->buyDID::", e);
                                    let obj = new RawView(res);
                                    obj.prepare({
                                        error_code: 0,
                                        status: 502,
                                        message: "Something Went Wrong"
                                    });
                                    obj.execute()
                                }

                            }
                            else {
                                let obj = new RawView(res);
                                obj.prepare({
                                    error_code: 0,
                                    status: 404,
                                    message: "DID not Available!"
                                });
                                obj.execute()
                            }
                        });
                    }

                    // To purchase the local number
                    else {
                        let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:placeOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><order><orderType>NN</orderType><orderNumbers><number><tn>' + sdata.DID.trim() + '</tn><mou>1000</mou><routeLabel>TRAYTECH_03</routeLabel><peerlessMsgProvisioning>?</peerlessMsgProvisioning></number></orderNumbers></order></pub:placeOrder></soapenv:Body></soapenv:Envelope>';

                        let options: any = {
                            'method': 'POST',
                            'url': this.url,
                            'headers': {
                                'Content-Type': 'text/xml',
                                'SOAPAction': 'placeOrder'
                            },
                            body: data,
                        };
                        request(options, (error: any, response: any, body: any) => {
                            if (!error) {
                                try {
                                    let tmp = body;
                                    var result1 = convert.xml2json(tmp, { compact: true, spaces: 4 });
                                    let res1 = JSON.parse(result1);
                                    // If order placed successfully
                                    if (typeof res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"] != 'undefined') {
                                        let providerOrderId: any = typeof res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"]["return"] != 'undefined' && res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"]["return"]["_text"] ? res1["S:Envelope"]["S:Body"]["ns2:placeOrderResponse"]["return"]["_text"] : ''

                                        let order: any = providerOrderId;
                                        let dateObj = new Date();
                                        let day = dateObj.getUTCDate();

                                        let nDate: any = new Date()
                                        let lDate: any = (new Date(nDate.getFullYear(), (nDate.getMonth() + 1), 0)).getDate()
                                        let totalDays = (lDate - day) + 1;

                                        let prorate: any;
                                        if (proration_status == "true") {
                                            prorate = (totalDays * did_details[0].rates) / lDate;
                                        }
                                        else {
                                            prorate = did_details[0].rates;
                                        }
                                        prorate = typeof prorate != 'undefined' && prorate > 0 ? prorate : 0

                                        let obj = new ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_buy` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`inbound_key`,`outbound_key`,`connection_key`,`sms_inbound_key`,`sms_outbound_key`,`rates`,`camp_registry`,`idapi`,`pro_rates`,`did_disconnect_days`,`nrc_rates`) VALUE('" + this.sessdata.idaccount + "','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + sdata.InboundVoice + "','" + sdata.OutboundVoice + "','" + sdata.Connection + "','" + sdata.InboundSMS + "','" + sdata.OutboundSMS + "','" + did_details[0].rates + "','" + sdata.CampaignId + "','" + setToZero(this.sessdata.idapi) + "','" + prorate + "','" + did_dis_days + "','" + did_details[0].rates + "')";
                                        obj.prepare();
                                        obj.execute((err, data) => {
                                            if (err == 1) {

                                                // update end subscription date
                                                let obj0 = new ModelRawQuery(req, res);
                                                obj0.qrysql = "SELECT d.iddid, d.iduser, d.account_id, d.user_id,IF(DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY) >NOW(),DATE_ADD(d.`created_at`,INTERVAL t.day_num DAY),LAST_DAY(NOW()))AS subscription_end_date,DATE_FORMAT(d.`created_at`,'%Y-%m-%d %H:%i:%s')`created_at` FROM `did_buy`d LEFT JOIN `endpoint`e ON d.connection_key = e.connection_key INNER JOIN  `user`u ON d.iduser=u.iduser INNER JOIN `tariff` t ON t.idtariff=u.idtariff WHERE d.iddid='" + data.insertId + "' AND disconnect_did_status = '1'";
                                                obj0.prepare();
                                                obj0.execute((dids_err, didRes) => {
                                                    let dates = didRes[0].subscription_end_date;
                                                    let isoDate = new Date(dates);
                                                    let subscriptionEndDate = isoDate.toJSON().slice(0, 19).replace('T', ' ');
                                                    let obj01 = new ModelRawNonQuery(req, res);
                                                    obj01.nonqrysql = "UPDATE `did_buy` SET `subscription_end_date`='" + subscriptionEndDate + "' WHERE `iddid`=" + didRes[0].iddid + ";"
                                                    obj01.prepare();
                                                    obj01.execute((error, result) => { })
                                                })
                                                let objv = new ModelRawNonQuery(req, res);
                                                objv.nonqrysql = "UPDATE `wallet` SET `balance`=`balance`-" + prorate + " WHERE `idaccount`='" + this.sessdata.idaccount + "'"
                                                objv.prepare();
                                                objv.execute((wallet_error, wallet_success) => {

                                                    // To update the wallet transaction log
                                                    let iQry: string = "INSERT INTO `wallet_recharge_log` SET "
                                                    iQry += "`idaccount`=" + this.sessdata.idaccount + ", "
                                                    iQry += "`amount`='-" + prorate + "', "
                                                    iQry += "`purpose`='Wallet amount successfully updated for buy a new DID', "
                                                    iQry += "`status`=1;"

                                                    let objWL = new ModelRawNonQuery(req, res);
                                                    objWL.nonqrysql = iQry
                                                    objWL.prepare()
                                                    objWL.execute((error: any, result: any) => {
                                                    })

                                                    // To create the DID log
                                                    let objv1 = new ModelRawNonQuery(req, res);
                                                    objv1.nonqrysql = "INSERT INTO `did_log` (`account_id`, `user_id`, `status`, `did`,`provider`,`order_id`,`type`,`iduser`,`disconnect_did_status`,`npa`,`nxx`,`state`,`ratecenter`,`rates`,`idapi`,`pro_rates`,`event_type`,`description`,`full_log`) VALUE('" + this.sessdata.idaccount + "','','completed','" + sdata.DID.trim() + "','Peerless','" + order + "','NN','" + this.sessdata.iduser + "','1','" + npa + "','" + nxx + "','" + state + "','" + ratecenter + "','" + did_details[0].rates + "','" + this.sessdata.idapi + "','" + prorate + "','1','DID Buy','" + res1 + "')";
                                                    objv1.prepare();
                                                    objv1.execute((log_error, did_log) => { });

                                                    // To delete the DID from cart
                                                    let obj5 = new ModelRawNonQuery(req, res);
                                                    obj5.nonqrysql = "DELETE FROM `did_cart` WHERE did='" + sdata.DID + "'"
                                                    obj5.prepare();
                                                    obj5.execute((walletError: any, wallet: any) => { });

                                                    // To update the process count of group order
                                                    let objk = new ModelRawNonQuery(req, res)
                                                    objk.nonqrysql = "UPDATE `did_group_order` SET `process_dids`=`process_dids`+ 1 WHERE `id_grouporder`=" + id_grouporder + ";"
                                                    objk.prepare()
                                                    objk.execute((error, result) => {
                                                        console.log("GroupOrder process count::\n", result)
                                                    })

                                                    // To create the did_order
                                                    let obj = new ModelRawNonQuery(req, res);
                                                    obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`,`error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '201','" + sdata.DID + "', '2', 'NN', '" + did_details[0].rates + "', 'Order successfully created.', " + id_grouporder + ", 1)";
                                                    obj.prepare();
                                                    obj.execute((did_err, did_data) => {
                                                        // To update the other data on current order
                                                        if (did_err == 1) {
                                                            let id_order: number = did_data.insertId
                                                            let orderID: string = "SORD" + id_order.toString()

                                                            let log_error: string = ""
                                                            let log_message: string = "Order successfully created."
                                                            let log_result: string = JSON.stringify(res1).replace(/'/g, "\\'").replace(/"/g, '\\"')

                                                            obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='200', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=0, `provider`='Peerless', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";"
                                                            obj.prepare();
                                                            obj.execute((error, result) => { })
                                                        }

                                                        if (sdata.CampaignId) {
                                                            let osr = new OsrApi(this.priority, this.sessdata);
                                                            osr.updateNumber(req, res, data.insertId, (error, responce) => { })
                                                        }
                                                        else {
                                                            let obj = new RawView(res);
                                                            obj.prepare({
                                                                error_code: 1,
                                                                status: 201,
                                                                message: "DID buy successfully.",
                                                                result: [
                                                                    {
                                                                        "did": did
                                                                    }
                                                                ]
                                                            });
                                                            obj.execute()
                                                        }
                                                    });
                                                });
                                            }
                                            else {
                                                let obj = new RawView(res);
                                                obj.prepare({
                                                    error_code: 0,
                                                    status: 502,
                                                    message: "Something went wrong with connection!"
                                                });
                                                obj.execute()
                                            }
                                        });
                                    }

                                    // If order failed
                                    else if (typeof res1["S:Envelope"]["S:Body"]["S:Fault"] != 'undefined') {
                                        let Fault: any = res1["S:Envelope"]["S:Body"]["S:Fault"]

                                        let providerOrderId: any = ''

                                        let obj = new ModelRawNonQuery(req, res);
                                        obj.nonqrysql = "INSERT INTO `did_order` (`iduser`, `idaccount`, `status`, `did`, `error_code`, `type`, `cost`, `description`, `id_grouporder`, `is_process`) VALUE('" + this.sessdata.iduser + "', '" + this.sessdata.idaccount + "', '501', '" + did + "', '4', 'TF', '" + did_details[0].rates + "', 'Order creation failed!', " + id_grouporder + ", 1)";
                                        obj.prepare();
                                        obj.execute((did_err, did_data) => {
                                            // To update the other data on current order
                                            if (did_err == 1) {
                                                let id_order: number = did_data.insertId
                                                let orderID: string = "SORD" + id_order.toString()

                                                let log_error: string = JSON.stringify(res1).replace(/'/g, "\\'").replace(/"/g, '\\"')
                                                let log_message: string = (Fault['faultcode'] + ' - ' + Fault['faultstring']).replace(/'/g, "\\'").replace(/"/g, '\\"')
                                                let log_result: string = ""

                                                obj.nonqrysql = "UPDATE `did_order` SET `order_no`='" + orderID + "', `log_statusCode`='501', `log_error`='" + log_error + "', `log_message`='" + log_message + "', `log_result`='" + log_result + "', `log_status`=1, `provider`='Peerless', `providerOrderId`='" + providerOrderId + "' WHERE `id_order`=" + id_order + ";"
                                                obj.prepare();
                                                obj.execute((error, result) => { })
                                            }
                                        });

                                        let objn = new ModelRawNonQuery(req, res);
                                        objn.nonqrysql = "INSERT INTO `did_log`(`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + this.sessdata.iduser + "',NOW(),'40','DID Buy failed from provider','" + sdata.DID.trim() + "','" + res1 + "')"
                                        objn.prepare();
                                        objn.execute((errorDiDLg: any, resDiDLg: any) => {
                                            console.log("DID Buy failed from provider");
                                        });

                                        let objV = new RawView(res);
                                        objV.prepare({
                                            error_code: 0,
                                            status: 502,
                                            message: Fault['faultstring'],
                                            error: Fault['faultcode'] + ' - ' + Fault['faultstring']
                                        });
                                        objV.execute();
                                    }
                                    else {
                                        let obj = new RawView(res);
                                        obj.prepare({
                                            error_code: 0,
                                            status: 502,
                                            message: "Something Went Wrong"
                                        });
                                        obj.execute()
                                    }
                                }
                                catch (e) {
                                    console.log("Error :: Peerless->buyDID::", e);
                                    let obj = new RawView(res);
                                    obj.prepare({
                                        error_code: 0,
                                        status: 502,
                                        message: "Something Went Wrong"
                                    });
                                    obj.execute()
                                }

                            }
                            else {
                                let obj = new RawView(res);
                                obj.prepare({
                                    error_code: 0,
                                    status: 404,
                                    message: "DID not Available!"
                                });
                                obj.execute()
                            }
                        });
                    }
                }
                else {
                    let obj = new RawView(res);
                    obj.prepare({
                        error_code: 0,
                        status: 502,
                        message: "Something went wrong with get proration!"
                    });
                    obj.execute();
                }
            });
        });
    }

    disconnectDID(req: Request, res: Response, payload: any, callback: (err: any, data: any) => void) {
        const sdata = req.body;
        let iduser: number = (typeof sdata.iduser != 'undefined' && sdata.iduser > 0) ? sdata.iduser : this.sessdata.iduser;
        let data = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:pub="http://publicapi.api.s2.peerless.com/"><soapenv:Body><pub:disconnectOrder><authentication><customer>' + this.customer + '</customer><passCode>' + this.passCode + '</passCode><userId>' + this.userId + '</userId></authentication><disconnectOrderRequest><pon>?</pon><tns><tn>' + sdata.DID.trim() + '</tn><discoType>1</discoType></tns></disconnectOrderRequest></pub:disconnectOrder></soapenv:Body></soapenv:Envelope>';
        var options: any = {
            'method': 'POST',
            'url': this.url,
            'headers': {
                'Content-Type': 'text/xml',
                'SOAPAction': 'disconnectOrder'
            },
            'body': data,
        };
        request(options, (error: any, response: any, body: any) => {
            if (!error) {
                try {
                    if (body) {
                        var result1 = convert.xml2json(body, { compact: true, spaces: 4 });
                        let res1 = JSON.parse(result1);
                        // let data = res1["S:Envelope"]["S:Body"]["ns2:disconnectOrderResponse"]["return"]["_text"];
                        let data: any = '';
                        if (res1["S:Envelope"]["S:Body"]["ns2:disconnectOrderResponse"]) {
                            data = res1["S:Envelope"]["S:Body"]["ns2:disconnectOrderResponse"]["return"]["_text"];
                        }
                        if (data) {
                            let obj = new ModelRawNonQuery(req, res);
                            obj.nonqrysql = "UPDATE `did_buy` set `disconnect_did_status`='3',`updated_at`=NOW() WHERE `did`='" + sdata.DID.trim() + "'AND `iduser`='" + iduser + "'";
                            obj.prepare();
                            obj.execute((error: any, resp: any) => {
                                if (error == 1) {
                                    // To  update updated_at date in did log
                                    let obj = new ModelRawNonQuery(req, res);
                                    //obj.nonqrysql = "UPDATE `did_log` SET `event_type`='5',`description`='DID Disconnect Successfully',`updated_at`=NOW(), `disconnect_did_status`='3' WHERE `did`='" + sdata.DID.trim() + "' AND `iduser`='" + iduser + "' ORDER BY `iddidlog` DESC LIMIT 1"
                                    obj.nonqrysql = "INSERT INTO `did_log` (`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + iduser + "',NOW(),'41','Requested to Disconnect DID from Peerless','" + sdata.DID.trim() + "','" + res1 + "')"
                                    obj.prepare();
                                    obj.execute((errorDiDLg: any, resDiDLg: any) => {
                                        console.log("Requested to Disconnect DID from Peerless");
                                        });

                                    // To delete the number from Final Step/OSR/Sinch
                                    // Now The final disconnect response will be received by the webhook

                                    let objv = new RawView(res)
                                    objv.prepare({ status: 201, message: "DID Disconnected Successfully" })
                                    objv.execute()
                                }
                                else {
                                    let objv = new RawView(res);
                                    objv.prepare({ status: 502, message: "Something Went Wrong" });
                                    objv.execute();
                                }
                            })
                        }
                        else {

                            let objn = new ModelRawNonQuery(req, res);
                            objn.nonqrysql = "INSERT INTO `did_log`(`account_id`,`iduser`,`updated_at`,`event_type`,`description`,`did`,`full_log`) VALUE('" + this.sessdata.idaccount + "','" + this.sessdata.iduser + "',NOW(),'42','Request Failed to Disconnect DID from Peerless','" + sdata.DID.trim() + "','" + res1 + "')"
                            objn.prepare();
                            objn.execute((errorDiDLg: any, resDiDLg: any) => {
                                console.log("Request Failed to Disconnect DID from Peerless");
                            });

                            let objv = new RawView(res);
                            objv.prepare({ status: 502, message: "DID disconnect failed!" });
                            objv.execute()
                        }
                    }
                    else {
                        let objv = new RawView(res);
                        objv.prepare({ status: 402, message: "DID not able to disconnect!" });
                        objv.execute()
                    }
                }
                catch (e) {
                    console.log("Error :: Peerless->disconnectDID::", e);
                    let objv = new RawView(res);
                    objv.prepare({ status: 401, message: "DID not Disconnected!!" });
                    objv.execute()
                }
            }
            else {
                console.log("Peerless :::::::::::::::::::");
                let objv = new RawView(res);
                objv.prepare({ status: 400, error: error, message: "DID not Disconnected!" });
                objv.execute()
            }
        });            
    }

}